/*
	GIF.c
*/

#include	"defs.h"
#include	"GIF.h"
#include	"gifslice.h"

extern int	loadGIFfile( picsliceinfo* );
extern int	drawGIF( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );

void
GIFLoad()
{
	picsliceinfo	psi;
	int	ret;

	if( fp ){
		psi.fn= 0;
	}else if( (psi.fn= OPEN( File, 0 )) < 0 ){
		error( "No such file" );
	}
	if( ( ret= loadGIFfile( &psi ) ) != PICSLICE_NORMAL ){
		if( ret == PICSLICE_NOMEMORY ){
			error ("Insufficient memory");
		}else {
			error( "Is not gif format" );
		}
	}
	Width= psi.Width;
	Height= psi.Height;
	MaxColorGuaranteed= psi.BitPixel;

	/*	AllocateScreen()	*/
    if( Screen )	MFREE( Screen );
    if( (int)( Screen= (int16*)MALLOC( Size= Width * Height * 2 ) ) < 0 ){
		EndOfDraw( &psi );
		error ("Insufficient memory");
	}

	(unsigned short*)psi.chainbuf= Screen;
	if( ( ret= drawGIF( &psi ) ) != PICSLICE_TERMINATE ){
		error( "load error" );
	}else {
		unsigned short	*w= Screen + Size / 2;
		unsigned char	*r;
		int	i;

		r= (unsigned char*)(psi.ColorMap);
		for( i= 0; i < MaxColorGuaranteed; i++ ){
			Green[i]= *r++;
			Red[i]= *r++;
			Blue[i]= *r++;
		}

		if( OutBpp == 1 ){
			InBpp= 64 + 1;
			SETBLOCK( Screen, Size / 2 );
		}else {
			r= (unsigned char*)(Screen + Size / 4);
			for( i= 0 ; i< Size / 2 ; i++ ){
				*--w= *--r;
			}
		}
	}
}
