* PIC loader for coerce X68K
*
* original PICSLICE.C by A.TAN
* modified 1999/04/25 by Rick

RUNS_HUMAN_VERSION	equ	3
	.include doscall.mac

	.text

READBIT1	macro
	local	nextbyte,thisbit

	dbra	d7,thisbit		*readbit
	dbra	d6,nextbyte
	bsr	readData
	bra	thisbit
nextbyte
	addq.l	#2,(a0)
	moveq.l	#15,d7
thisbit
	moveq.l	#0,d0
	movea.l	(a0),a1
	lsl.w	(a1)
	scc	d0
	addq.b	#1,d0

	endm

READBIT2	macro
	local	more,next2,this2

	movea.l	(a0),a1
	moveq.l	#0,d1
more
	dbra	d7,this2
	dbra	d6,next2
	bsr	readData
	movea.l	(a0),a1
	bra	this2
next2
	addq.w	#2,a1
	moveq.l	#15,d7
this2
	move.w	(a1),d1
	add.l	d1,d1
	move.w	d1,(a1)
	dbra	d2,more
	move.l	a1,(a0)
	moveq.l	#0,d0
	swap.w	d1
	move.w	d1,d0

	endm

READBIT	macro
	local	get,exist,check

	movea.l	(a0),a1
	moveq.l	#0,d1
	bra	check
get
	moveq.l	#0,d2
	move.w	d7,d0
	sub.w	d0,d3
	move.w	(a1),d2
	lsl.l	d0,d2
	move.w	d2,(a1)
	swap.w	d2
	lsl.l	d0,d1
	or.w	d2,d1
	dbra	d6,exist
	bsr	readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	check
exist
	addq.w	#2,a1
	moveq.l	#16,d7
check
	cmp.w	d7,d3
	bgt	get
	sub.w	d3,d7
	moveq.l	#0,d2
	move.w	(a1),d2
	lsl.l	d3,d2
	move.w	d2,(a1)
	swap.w	d2
	move.l	a1,(a0)
	lsl.l	d3,d1
	or.w	d2,d1
	move.l	d1,d0

	endm

READBIT7	macro
	local	next7,this7

	movea.l	(a0),a1
	moveq.l	#0,d1
	cmp.w	d7,d3
	ble	this7
	sub.w	d7,d3
	move.w	(a1),d1
	lsl.l	d7,d1
	move.w	d1,(a1)
	dbra	d6,next7
	bsr	readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	this7
next7
	addq.w	#2,a1
	moveq.l	#16,d7
this7
	sub.w	d3,d7
	move.w	(a1),d1
	lsl.l	d3,d1
	move.w	d1,(a1)
	swap.w	d1
	move.l	a1,(a0)
	moveq.l	#0,d0
	move.w	d1,d0

	endm

squarecomment:
	.dc.b	"/XSS/"
	.even

	.globl	_loadPICfile
_loadPICfile:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	move.l	36(sp),a0	*psi
	movea.l	a0,a5		*psi
	move.l	#16384,d0
	move.l	d0,8(a0)	*filebufsize
	move.l	d0,-(sp)
	DOS	__MALLOC
	addq.w	#4,sp
	tst.l	d0
	bgt	memoryok
	move.l	#205,d0		*PICSLICE_NOMEMORY
	bra	openerror
memoryok:
	move.l	d0,4(a0)	*filebuf
	lea.l	12(a0),a0	*currentbyte
	move.l	d0,(a0)		*currentbyte
	moveq.l	#0,d2
	move.l	d2,d6		*bytecount
	move.l	d2,d7		*bitcount
	move.w	d2,42(a0)	*freelist(_readerror)

	bsr	readchr		*init

	bsr	readchr
	cmp.b	#'P',d0
	bne	eformat
	bsr	readchr
	cmp.b	#'I',d0
	bne	eformat
	bsr	readchr
	cmp.b	#'C',d0
	bne	eformat
	lea.l	squarecomment(OPC),a2
nomatch:
	moveq.l	#0,d2
comment_lp:
	bsr	readchr
	cmp.b	#$1a,d0
	beq	skip_lp
	cmp.b	#5,d2
	bge	comment_lp
	cmp.b	(a2,d2.l),d0
	bne	nomatch
	addq.b	#1,d2
	bra	comment_lp
skip_lp:
	tst.l	_NoExpand
	bpl	nocheck_adjust
	moveq.l	#0,d0
	cmp.b	#5,d2
	sne	d0
	addq.b	#1,d0
	move.l	d0,_NoExpand
nocheck_adjust:
	bsr	readchr
	tst.b	d0
	bne	skip_lp
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	moveq.l	#15,d2
	cmp.b	d0,d2
	beq	format_ok
eformat:
	moveq.l	#101,d0
	add.w	d0,d0		*PICSLICE_EFORMAT
	bra	openerror
format_ok:
	bsr	readchr
	lea	20(a5),a4	*width
	asl.l	#8,d0
	move.l	d0,(a4)
	bsr	readchr
	add.l	d0,(a4)+
	bsr	readchr
	asl.l	#8,d0
	move.l	d0,(a4)		*height
	bsr	readchr
	add.l	d0,(a4)

	move.l	-(a4),d1	*width
	add.w	d1,d1
	move.l	d1,-(a4)	*realwidth
	moveq.l	#0,d2
	move.l	d2,28(a5)
	move.w	d2,36(a5)
	move.l	d2,46(a5)	*y		34(a0)
	move.l	a5,a1

	moveq.l	#0,d1
	moveq.l	#127,d2
ctbl_init_lp:
	lea.l	(a1,d1.w),a2
	clr.w	66(a2)
	subq.w	#2,d1
	move.b	d1,323(a2)	*prev
	addq.w	#4,d1
	move.b	d1,322(a2)	*next
	dbra	d2,ctbl_init_lp

	clr.w	1346(a1)
	moveq.l	#0,d3
firstlen_lp:
	addq.l	#1,d3
	READBIT1
	bne	firstlen_lp

	move.l	d3,-(sp)
	READBIT
	move.l	(sp)+,d3
	move.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea	-2(a2,d0.l),a2
	move.l	a2,32(a5)
	tst.w	54(a5)
	beq	normal
	move.l	#203,d0		*PICSLICE_EREAD
	bra	openerror
normal:
	move.w	d6,48(a0)	*bytecount
	move.w	d7,52(a0)	*bitcount
	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
	bra	readok
openerror:
	move.l	d0,d7
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
readok:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts

	.even
readchr:
	moveq.l	#0,d0
	movea.l	(a0),a1
	move.w	(a1),d0
	subq.w	#8,d7
	ble	lowbyte
	move.w	d0,d1
	lsl.w	#8,d1
	move.w	d1,(a1)
	lsr.w	#8,d0
	rts
lowbyte:
	lsr.w	#8,d0
	dbra	d6,exist_word
	move.l	d0,d1
	bsr	readData
	move.l	d1,d0
	rts
exist_word:
	addq.l	#2,(a0)
	moveq.l	#16,d7
	rts

	.even
readData:
	move.l	-4(a0),-(sp)
	move.l	-8(a0),-(sp)
	move.w	-10(a0),-(sp)
	DOS	__READ
	lea.l	10(sp),sp
	subq.w	#2,d0
	lsr.w	d0
	move.w	d0,d6
	bne	not_empty
	moveq.l	#1,d0
	move.w	d0,42(a0)
not_empty:
	move.l	-8(a0),(a0)
	moveq.l	#15,d7
	
	rts

	.even

	.globl _drawPIC
_drawPIC:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a0
	move.l	38(a0),50(a0)	*frame		38(a0)
	move.l	a0,-(sp)
	bsr	iclr
	addq.w	#4,sp

	lea.l	12(a0),a0
	moveq.l	#0,d5
	move.w	d5,42(a0)	*_readerror
	move.l	d5,d7
	move.w	48(a0),d6	*bytecount
	move.w	52(a0),d7	*bitcount
	movea.l	4(a0),a6	*realwidth
	movea.l	8(a0),a4	*width
	move.l	a4,d1		*width
	move.w	18(a0),a3	*currenty
	move.l	20(a0),a5	*runlength


top:
	lea.l	24(a0),a1	*color
	bra	not_end
?297:
	move.l	a4,d0	*width
	sub.l	d5,d0
	sub.l	d0,a5	*runlength
	moveq.l	#0,d5
	movea.l	38(a0),a2	*frame
	move.w	10(a0),d1	*width
	move.w	(a1),d2
	bra	draw_lp_ent
draw_lp:
	move.w	(a2),d0		*frame
*	ror.b	#1,d0		*ibit_check
	bpl	i_off
*	add.b	d0,d0
	and.w	#$7fff,d0
	move.w	d0,d2
i_off:
	move.w	d2,(a2)+	*color->frame
draw_lp_ent:
	dbra	d1,draw_lp

	move.w	d2,(a1)		*color
	move.l	a6,d0
	add.l	d0,38(a0)	*frame

	addq.w	#1,a3
	move.w	a3,d0		*currenty
	cmp.w	14(a0),d0
	bne	not_end
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	endop
not_end:
	move.l	d5,d0
	add.l	a5,d0		*runlength
	cmp.l	a4,d0		*width
	bge	?297
	add.l	a5,d5		*runlength

*readColor
	READBIT1
	bne	cache
	moveq.l	#15,d3
	READBIT7
	lea	1334(a0),a1	*current
	move.w	(a1),d1
	lea.l	-12(a0,d1.w),a2
	move.b	322(a2),d3
	move.w	d3,(a1)
	add.w	d0,d0
	move.w	d0,54(a0,d3.w)
	move.w	d0,d3
	bra	cwrite
cache:
	moveq.l	#7,d3
	READBIT7
	move.l	d0,d2
	add.w	d2,d2
	move.w	1334(a0),d1
	cmp.w	d1,d2
	beq	same
	lea	310(a0),a1	*prev
	lea.l	(a1,d2.w),a2
	move.b	(a2)+,d0	*prev[idx]
	move.b	(a2),d3		*next[idx]
	move.b	d1,(a2)		*cc->next[idx]
	move.b	d0,(a1,d3.w)	*prev[idx]->prev[next[idx]]
	move.b	d3,1(a1,d0.w)	*next[idx]->next[prev[idx]]
	move.b	(a1,d1.w),d0	*prev[cc]
	move.b	d0,-(a2)	*prev[cc]->prev[idx]
	move.b	d2,1(a1,d0.w)	*idx->next[prev[cc]]
	move.b	d2,(a1,d1.w)	*idx->prev[cc]

	move.w	d2,1334(a0)	*idx->current
same:
	move.w	54(a0,d2.w),d3	*color[idx]
cwrite:
	tst.w	42(a0)
	bne	eread

	move.l	d5,d0
	add.w	d0,d0
	movea.l	38(a0),a2	*frame
	addq.w	#1,d3
	ror.w	#1,d3
	move.w	d3,(a2,d0.w)
	READBIT1
	beq	getlen

*expandChain
	move.l	d5,-(sp)
	move.w	14(a0),d4	*height
	sub.w	a3,d4		*currenty
	subq.w	#1,d4
	movea.l	38(a0),a2	*frame
nextchain:
	moveq.l	#2-1,d2
	READBIT2
	bne	chain
	READBIT1
	beq	chain_end
	READBIT1
	beq	chain
	moveq.l	#4,d0
chain:
	subq.w	#2,d0
	add.w	d0,d5
	adda.l	a6,a2		*frame

	tst.w	d5
	blt	over
	cmp.w	10(a0),d5	*width
	bge	over
	dbra	d4,down		*height
over:
*	addq.w	#4,sp
*	bra	eread
	moveq.l	#2-1,d2
	READBIT2
	bne	over
	READBIT1
	beq	chain_end
	READBIT1
	bra	over
down:
	move.w	d5,d0
	add.w	d0,d0
	move.w	d3,(a2,d0.w)
	bra	nextchain
chain_end:
	move.l	(sp)+,d5

getlen:
	moveq.l	#0,d3
getlen_lp:
	addq.w	#1,d3
	READBIT1
	bne	getlen_lp

	movea.l	d3,a2
	READBIT
	move.l	a2,d3
	move.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea	-1(a2,d0.l),a5	*runlength
	tst.w	42(a0)
	beq	top
eread:
	move.l	#203,d0		*PICSLICE_EREAD
endop:
	move.l	d0,d7
	move.l	40(sp),-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even

iclr:				*gram i bit clr
	move.l	4(sp),a1	*psi
	movem.l	d3-d7/a3,-(sp)
	move.l	20(a1),d0	*width
	move.l	24(a1),d1	*height
	movea.l	38(a1),a1	*buf
	mulu	d1,d0
	add.l	d0,d0		*bufsize
	lea.l	(a1,d0.l),a1
	move.l	d0,d1
	lsr.l	#8,d1
	and.w	#$ff,d0

	moveq.l	#0,d2
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.l	d2,d7
	movea.l	d2,a2
	movea.l	d2,a3
	bra	clrlpent
clrxlp:
	rept 8

	movem.l	d2-d7/a2-a3,-(a1)

	endm
clrlpent:
	subq.l	#1,d1
	bpl	clrxlp

	bra	clrlp2ent
clrlp2:
	move.w	d2,(a1)+
clrlp2ent:
	dbra	d0,clrlp2

	movem.l	(sp)+,d3-d7/a3
	rts

	.even
	.end
