/*
//	coerce.cc -- $@MM!9$J%U%)!<%^%C%H$N2hA|%U%!%$%k$rAj8_$KJQ49$9$k(J
//
//		created    in 2/11/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"defs.h"
#include	"Beta.h"
#include	"Mag.h"
#include	"Maki.h"
#include	"ML1.h"
#include	"Pi.h"
#include	"Pic.h"
#include	"PPM.h"
#include	"GLM.h"
#include	"BMP.h"
#include	"GIF.h"
#include	"PCD.h"

void	Usage();
char	*ReplaceExtension( char *Original, char *Extension );

void	Usage()
{
    fputs( "coerce: a graphic format converter ver 1.00\n", stderr );
    fputs( "usage: coerce [option] [files]\n", stderr );
    fputs( "input formats:  -{mag,pi,pic,maki,ppm,pbm,ml1,beta,glm,bmp,gif,pcd0,pcd1,pcd2}\n", stderr );
    fputs( "output formats: +{mag,pi,pic,ppm,beta,glm,bmp}\n", stderr );
    fputs( "option: -adjust -notadjust -stdin -stdout -o [name] -quiet\n", stderr );
    exit (1);
}

int 	main( int argc, char *argv[] )
{
    int 	i, j;
    int 	SourceFormat, DestinationFormat;
    int 	FromStdin, ToStdout, Quiet, Infer;
	int		vsflag;
	char *tmp1, *tmp2;
	char table1[]= "0123456789abcdefABCDEF";
	char table2[]= { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
					13, 14 ,15, 10, 11, 12, 13, 14, 15 };
    
    Program = argv[0];
    Initialize();
    SourceFormat = UNKNOWN;
    DestinationFormat = BETA;
    FromStdin = 0;
    ToStdout = 0;
    NoExpand = -1;
    File = "";
    fp = NULL;
    Quiet = 0;
    Infer = 0;
    vsflag = 0;
    if ( argc == 1 )
	Usage();
    for ( i = 1; i < argc; i++ ) {
	if ( *argv[i] == '-' ) {
	    if ( strcmp( argv[i], "-stdin" ) == 0 )
		FromStdin = 1;
	    else if ( strcmp( argv[i], "-stdout" ) == 0 ) {
		ToStdout = 1;
		Quiet = 1;
	    }
	    else if ( strcmp( argv[i], "-adjust" ) == 0 )
		NoExpand = 0;
	    else if ( strcmp( argv[i], "-notadjust" ) == 0 )
		NoExpand = 1;
	    else if ( strcmp( argv[i], "-o" ) == 0 ) {
		ToStdout = ++i;
	    }
	    else if ( argv[i][1] == 'V' && argv[i][2] == 'S' ){
	    	vsflag = 1;
	    	tmp1= argv[i] + 3;
	    	if( !(tmp2= strchr( tmp1, ',' ) ) )	Usage();
	    	*tmp2++= '\0';
	    	Width= atoi( tmp1 );
	    	if( !(tmp1= strchr( tmp2, ',' ) ) )	Usage();
	    	*tmp1= '\0';
	    	Height= atoi( tmp2 );
			tmp1 += 2;
	    	Screen= 0;
	    	while( *tmp1 ){
	    		(int)Screen = (int)Screen << 4;
				if( !(tmp2= strchr( table1, *tmp1 ) ) )	Usage();
				(int)Screen+= table2[tmp2 - table1];
				tmp1++;
			}
			Size= Width * Height * 2;
			SourceFormat = VS;
	    }
	    else {
		for ( j = 1; j < NumberofFormats; j++ ) 
		    if ( strcmp( argv[i] + 1, Format[j] ) == 0 )
			break;
		if ( j == NumberofFormats )
		    Usage();
		SourceFormat = j;
	    }
	}
	else if ( *argv[i] == '+' ) {
	    for ( j = 1; j < NumberofFormats; j++ )
		if ( strcmp( argv[i] + 1, Format[j] ) == 0 )
		    break;
	    if ( j == NumberofFormats )
		Usage();
	    DestinationFormat = j;
	}
	else {
	    if ( !setjmp (ErrorEntry) ) {
		if ( FromStdin )
		    error ("Input is specified doubly");
		if ( Infer )
		    SourceFormat = UNKNOWN;
		if ( SourceFormat == UNKNOWN ) {
		    SourceFormat = InferFormat (argv[i]);
		    Infer = 1;
		}
		else
		    Infer = 0;
		if ( SourceFormat == UNKNOWN )
		    error ("Source format is not specified");
		fp = NULL;
		if( vsflag )
			File = " ";
		else
			File = argv[i];
		if ( !Quiet ) {
			printf( "%s(%s) -> ", File, Format[SourceFormat] );
		    fflush (stdout);
		}

		InBpp= Bpp[SourceFormat];
		OutBpp= Bpp[DestinationFormat];

		switch (SourceFormat) {
		    case BETA: BetaLoad(); break;
		    case MAG: MagLoad(); break;
		    case MAKI: MakiLoad(); break;
		    case ML1: ML1Load(); break;
		    case PBM: PBMLoad(); break;
		    case PI: PiLoad(); break;
		    case PIC: PicLoad(); break;
		    case PPM: PPMLoad(); break;
			case GLM: GLMLoad(); break;
			case VS: RightShift(); break;
			case BMP: BMPLoad(); break;
			case GIF: GIFLoad(); break;
			case PCD0: PCD0Load(); break;
			case PCD1: PCD1Load(); break;
			case PCD2: PCD2Load(); break;
		    default:
			error ("Sorry, not implemented");
		}

		ColorManager();

		if ( ToStdout == 0 ) {
		    fp = NULL;
			if( vsflag )
				File= argv[i];
			else
			    File = ReplaceExtension( argv[i], Extension[DestinationFormat] );
		}
		else if ( ToStdout == 1 ) {
		    fp = stdout;
		    File = "stdout";
		}
		else {
		    fp = NULL;
		    if( vsflag )
		    	File = argv[ToStdout - 1];
		    else
			    File = argv[ToStdout];
		}
		if ( !Quiet )
			printf( "%s(%s)\n", File, Format[DestinationFormat] );
		switch (DestinationFormat) {
		    case BETA: BetaSave(); break;
		    case MAG: MagSave(); break;
		    case PI: PiSave(); break;
		    case PIC: PicSave(); break;
		    case PPM: PPMSave(); break;
			case GLM: GLMSave(); break;
			case BMP: BMPSave(); break;
		    default:
			error ("Sorry, not implemented");
		}
	    }
	}
    }
    if ( FromStdin && !setjmp (ErrorEntry) ) {
	fp = stdin;
	if ( SourceFormat == UNKNOWN )
	    error ("Source format is not specified");
	if ( ToStdout == 0 || ToStdout == 1 )
	    Quiet = 1;
	if ( !Quiet ) {
		printf( "stdin(%s) -> ", Format[SourceFormat] );
	    fflush (stdout);
	}
	InBpp= Bpp[SourceFormat];
	OutBpp= Bpp[DestinationFormat];

	switch (SourceFormat) {
	    case BETA: BetaLoad(); break;
	    case MAG: MagLoad(); break;
	    case MAKI: MakiLoad(); break;
	    case ML1: ML1Load(); break;
	    case PBM: PBMLoad(); break;
	    case PI: PiLoad(); break;
	    case PIC: PicLoad(); break;
	    case PPM: PPMLoad(); break;
		case GLM: GLMLoad(); break;
		case VS: RightShift(); break;
		case BMP: BMPLoad(); break;
		case GIF: GIFLoad(); break;
		case PCD0: PCD0Load(); break;
		case PCD1: PCD1Load(); break;
		case PCD2: PCD2Load(); break;
	    default:
		error ("Sorry, not implemented");
	}
	ColorManager();

	if ( ToStdout == 0 || ToStdout == 1 ) {
	    fp = stdout;
	    File = "stdout";
	}
	else {
	    fp = NULL;
	    if( vsflag )
	    	File = argv[ToStdout - 1];
	    else
		    File = argv[ToStdout];
	}
	if ( !Quiet )
		printf( "%s(%s)\n", File, Format[DestinationFormat] );
	switch (DestinationFormat) {
	    case BETA: BetaSave(); break;
	    case MAG: MagSave(); break;
	    case PI: PiSave(); break;
	    case PIC: PicSave(); break;
	    case PPM: PPMSave(); break;
		case GLM: GLMSave(); break;
		case BMP: BMPSave(); break;
	    default:
		error ("Sorry, not implemented");
	}
    }
    return 0;
}

char	*ReplaceExtension( char *Original, char *Extension )
{
    static char	Buffer[256];
    int 	i, j;

    j = -1;
    for ( i = 0; Original[i] != '\0'; i++ )
	if ( Original[i] == DSEPARATOR )
	    j = i;
    strcpy( Buffer, Original + j + 1 );
    for ( i = strlen (Buffer) - 1; i >= 0 && Buffer[i] != '.' && Buffer[i] != DSEPARATOR; i-- );
    if ( Buffer[i] == '.' )
	Buffer[i] = '\0';
    strcat( Buffer, "." );
    strcat( Buffer, Extension );
    return Buffer;
}
